function [rsupp,csupp] = suppgmat(evt,pinds,gammalen,evsubset)

if nargin < 4 || isempty(evsubset)
	evtsub = evt;
	nevs = numel(evt);
	argsub = false; % do we have the subset argument?
else
	evsubset = reshape(evsubset,[],1);
	evtsub = evt(evsubset);
	nevs = numel(evtsub);
	argsub = true;
end

procnevs = numel(pinds);

if procnevs == 0
	csupp = zeros(0,1);
	rsupp = zeros(0,1);
% 	val = rsupp;
	return
end

if ~issorted(evt)
	error('evt must be sorted')
end
% if gammalen > evt(end)-evt(1)
% 	[rsupp,csupp] = find(tril(true( %%%%%%%%%%%%% trivial output
% 	return
% end

if exist('repelem','builtin')
	fun_repelem = @repelem;
else
	fun_repelem = @repelem_backup;
end

rstart = ones(1,procnevs);
rstop = zeros(1,procnevs);
start = 1;
stop = 0;
for k = 1:procnevs
	evtk = evt(pinds(k));
	while start <= nevs && evtk >= evtsub(start) + gammalen
		start = start+1;
	end
	if stop < start
		stop = start-1;
	end
	while stop < nevs && evtk > evtsub(stop+1)
		stop = stop+1;
	end
	if start <= stop
		rstart(k) = start;
		rstop(k) = stop;
	end
end
rsupp = reshape(fun_repelem(1:procnevs,rstop-rstart+1),[],1);
csupp = reshape(cell2mat(arrayfun(@colon,rstart,rstop,'Uni',false)),[],1);

if argsub
	csupp = evsubset(csupp);
end
% val = gamma(evt(pinds(rsupp))-evt(csupp));
end

function w = repelem_backup(v,n)
% slower, limited version if repelem() isn't available (versions before R2015a)
cn = cumsum(n(:));
i = cumsum(accumarray(cn(1:end-1)+1,1,[cn(end),1]))+1;
w = v(i);
end
%{
function w = repelem_backup(v,n)
% old version, not as good
nn = numel(n);
cn = cumsum(n);
w = zeros(1,cn(nn));
w(1:cn(1)) = v(1);
for i = 2:nn
	w(cn(i-1)+1:cn(i)) = v(i);
end
end
%}